QEMU(1)

NAME
qemu-doc - QEMU Emulator User Documentation

SYNOPSIS
usage: qemu [options] [disk_image]

DESCRIPTION
The QEMU PC System emulator simulates the following peripherals:

-   i440FX host PCI bridge and PIIX3 PCI to ISA bridge

-   Cirrus CLGD 5446 PCI VGA card or dummy VGA card with Bochs VESA extensions (hardware level, including all non standard modes).

-   PS/2 mouse and keyboard

-   2 PCI IDE interfaces with hard disk and CD-ROM support

-   Floppy disk

-   PCI and ISA network adapters

-   Serial ports

-   Creative SoundBlaster 16 sound card

-   ENSONIQ AudioPCI ES1370 sound card

-   Intel 82801AA AC97 Audio compatible sound card

-   Adlib(OPL2) - Yamaha YM3812 compatible chip

-   Gravis Ultrasound GF1 sound card

-   CS4231A compatible sound card

-   PCI UHCI USB controller and a virtual USB hub.

SMP is supported with up to 255 CPUs.

Note that adlib, gus and cs4231a are only available when QEMU was configured with --audio-card-list option containing the name(s) of required card(s).

QEMU uses the PC BIOS from the Bochs project and the Plex86/Bochs LGPL VGA BIOS.

QEMU uses YM3812 emulation by Tatsuyuki Satoh.

QEMU uses GUS emulation(GUSEMU32 <http://www.deinmeister.de/gusemu/>) by Tibor "TS" SchA~Xtz.

CS4231A is the chip used in Windows Sound System and GUSMAX products

OPTIONS
disk_image is a raw hard disk image for IDE hard disk 0. Some targets do not need a disk image.

Standard options:

-h  Display help and exit

-version
    Display version information and exit

-M machine
    Select the emulated machine ("-M ?" for list)

-cpu model
    Select CPU model (-cpu ? for list and additional feature selection)

-smp n
    Simulate an SMP system with n CPUs. On the PC target, up to 255 CPUs are supported. On Sparc32 target, Linux limits the number of usable CPUs to 4.

-numa opts
    Simulate a multi node NUMA system. If mem and cpus are omitted, resources are split equally.

-fda file
-fdb file
    Use file as floppy disk 0/1 image. You can use the host floppy by using /dev/fd0 as filename.

-hda file
-hdb file
-hdc file
-hdd file
    Use file as hard disk 0, 1, 2 or 3 image.

-cdrom file
    Use file as CD-ROM image (you cannot use -hdc and -cdrom at the same time). You can use the host CD-ROM by using /dev/cdrom as filename.

-drive option[,option[,option[,...]]]
    Define a new drive. Valid options are:

    "file=file"
        This option defines which disk image to use with this drive. If the filename contains comma, you must double it (for instance, "file=my,,file" to use file "my,file").

    "if=interface"
        This option defines on which type on interface the drive is connected. Available types are: ide, scsi, sd, mtd, floppy, pflash, virtio.

    "bus=bus,unit=unit"
        These options define where is connected the drive by defining the bus number and the unit id.

    "index=index"
        This option defines where is connected the drive by using an index in the list of available connectors of a given interface type.

    "media=media"
        This option defines the type of the media: disk or cdrom.

    "cyls=c,heads=h,secs=s[,trans=t]"
        These options have the same definition as they have in -hdachs.

    "snapshot=snapshot"
        snapshot is "on" or "off" and allows to enable snapshot for given drive (see -snapshot).

    "cache=cache"
        cache is "none", "writeback", or "writethrough" and controls how the host cache is used to access block data.

    "format=format"
        Specify which disk format will be used rather than detecting the format. Can be used to specifiy format=raw to avoid interpreting an untrusted format header.

    "serial=serial"
        This option specifies the serial number to assign to the device.

    "addr=addr"
        Specify the controller's PCI address (if=virtio only).

    By default, writethrough caching is used for all block device. This means that the host page cache will be used to read and write data but write notification will be sent to the guest only when the data has been reported as written by the storage subsystem.

    Writeback caching will report data writes as completed as soon as the data is present in the host page cache. This is safe as long as you trust your host. If your host crashes or loses power, then the guest may experience data corruption. When using the -snapshot option, writeback caching is used by default.

    The host page cache can be avoided entirely with cache=none. This will attempt to do disk IO directly to the guests memory. QEMU may still perform an internal copy of the data.

    Some block drivers perform badly with cache=writethrough, most notably, qcow2. If performance is more important than correctness, cache=writeback should be used with qcow2.

    Instead of -cdrom you can use:

            qemu -drive file=file,index=2,media=cdrom

    Instead of -hda, -hdb, -hdc, -hdd, you can use:

            qemu -drive file=file,index=0,media=disk
            qemu -drive file=file,index=1,media=disk
            qemu -drive file=file,index=2,media=disk
            qemu -drive file=file,index=3,media=disk

    You can connect a CDROM to the slave of ide0:

            qemu -drive file=file,if=ide,index=1,media=cdrom

    If you don't specify the "file=" argument, you define an empty drive:

            qemu -drive if=ide,index=1,media=cdrom

    You can connect a SCSI disk with unit ID 6 on the bus #0:

            qemu -drive file=file,if=scsi,bus=0,unit=6

    Instead of -fda, -fdb, you can use:

            qemu -drive file=file,index=0,if=floppy
            qemu -drive file=file,index=1,if=floppy

    By default, interface is "ide" and index is automatically incremented:

            qemu -drive file=a -drive file=b"

    is interpreted like:

            qemu -hda a -hdb b

-mtdblock file
    Use 'file' as on-board Flash memory image.

-sd file
    Use 'file' as SecureDigital card image.

-pflash file
    Use 'file' as a parallel flash image.

-boot [order=drives][,once=drives][,menu=on|off]
    Specify boot order drives as a string of drive letters. Valid drive letters depend on the target achitecture. The x86 PC uses: a, b (floppy 1 and 2), c (first hard disk), d (first CD-ROM), n-p (Etherboot from network adapter 1-4), hard disk boot is the default. To apply a particular boot order only on the first startup, specify it via once.

    Interactive boot menus/prompts can be enabled via menu=on as far as firmware/BIOS supports them. The default is non-interactive boot.

            # try to boot from network first, then from hard disk
            qemu -boot order=nc
            # boot from CD-ROM first, switch back to default order after reboot
            qemu -boot once=d

    Note: The legacy format '-boot drives' is still supported but its use is discouraged as it may be removed from future versions.

-snapshot
    Write to temporary files instead of disk image files. In this case, the raw disk image you use is not written back. You can however force the write back by pressing C-a s.

-m megs
    Set virtual RAM size to megs megabytes. Default is 128 MiB. Optionally, a suffix of "M" or "G" can be used to signify a value in megabytes or gigabytes respectively.

-k language
    Use keyboard layout language (for example "fr" for French). This option is only needed where it is not easy to get raw PC keycodes (e.g. on Macs, with some X11 servers or with a VNC display). You don't normally need to use it on PC/Linux or PC/Windows hosts.

    The available layouts are:

            ar  de-ch  es  fo     fr-ca  hu  ja  mk     no  pt-br  sv
            da  en-gb  et  fr     fr-ch  is  lt  nl     pl  ru     th
            de  en-us  fi  fr-be  hr     it  lv  nl-be  pt  sl     tr

    The default is "en-us".

-audio-help
    Will show the audio subsystem help: list of drivers, tunable parameters.

-soundhw card1[,card2,...] or -soundhw all
    Enable audio and selected sound hardware. Use ? to print all available sound hardware.

            qemu -soundhw sb16,adlib disk.img
            qemu -soundhw es1370 disk.img
            qemu -soundhw ac97 disk.img
            qemu -soundhw all disk.img
            qemu -soundhw ?

    Note that Linux's i810_audio OSS kernel (for AC97) module might require manually specifying clocking.

            modprobe i810_audio clocking=48000

USB options:

-usb
    Enable the USB driver (will be the default soon)

-usbdevice devname
    Add the USB device devname.

    "mouse"
        Virtual Mouse. This will override the PS/2 mouse emulation when activated.

    "tablet"
        Pointer device that uses absolute coordinates (like a touchscreen). This means qemu is able to report the mouse position without having to grab the mouse. Also overrides the PS/2 mouse emulation when activated.

    "disk:[format=format]:file"
        Mass storage device based on file. The optional format argument will be used rather than detecting the format. Can be used to specifiy format=raw to avoid interpreting an untrusted format header.

    "host:bus.addr"
        Pass through the host device identified by bus.addr (Linux only).

    "host:vendor_id:product_id"
        Pass through the host device identified by vendor_id:product_id (Linux only).

    "serial:[vendorid=vendor_id][,productid=product_id]:dev"
        Serial converter to host character device dev, see "-serial" for the available devices.

    "braille"
        Braille device. This will use BrlAPI to display the braille output on a real or fake device.

    "net:options"
        Network adapter that supports CDC ethernet and RNDIS protocols.

-name name
    Sets the name of the guest. This name will be displayed in the SDL window caption. The name will also be used for the VNC server. Also optionally set the top visible process name in Linux.

-uuid uuid
    Set system UUID.

Display options:

-nographic
    Normally, QEMU uses SDL to display the VGA output. With this option, you can totally disable graphical output so that QEMU is a simple command line application. The emulated serial port is redirected on the console. Therefore, you can still use QEMU to debug a Linux kernel with a serial console.

-curses
    Normally, QEMU uses SDL to display the VGA output. With this option, QEMU can display the VGA output when in text mode using a curses/ncurses interface. Nothing is displayed in graphical mode.

-no-frame
    Do not use decorations for SDL windows and start them using the whole available screen space. This makes the using QEMU in a dedicated desktop workspace more convenient.

-alt-grab
    Use Ctrl-Alt-Shift to grab mouse (instead of Ctrl-Alt).

-no-quit
    Disable SDL window close capability.

-sdl
    Enable SDL.

-portrait
    Rotate graphical output 90 deg left (only PXA LCD).

-vga type
    Select type of VGA card to emulate. Valid values for type are

    "cirrus"
        Cirrus Logic GD5446 Video card. All Windows versions starting from Windows 95 should recognize and use this graphic card. For optimal performances, use 16 bit color depth in the guest and the host OS. (This one is the default)

    "std"
        Standard VGA card with Bochs VBE extensions. If your guest OS supports the VESA 2.0 VBE extensions (e.g. Windows XP) and if you want to use high resolution modes (>= 1280x1024x16) then you should use this option.

    "vmware"
        VMWare SVGA-II compatible adapter. Use it if you have sufficiently recent XFree86/XOrg server or Windows guest with a driver for this card.

    "none"
        Disable VGA card.

-full-screen
    Start in full screen.

-vnc display[,option[,option[,...]]]
    Normally, QEMU uses SDL to display the VGA output. With this option, you can have QEMU listen on VNC display display and redirect the VGA display over the VNC session. It is very useful to enable the usb tablet device when using this option (option -usbdevice tablet). When using the VNC display, you must use the -k parameter to set the keyboard layout if you are not using en-us. Valid syntax for the display is

    "host:d"
        TCP connections will only be allowed from host on display d. By convention the TCP port is 5900+d. Optionally, host can be omitted in which case the server will accept connections from any host.

    ""unix":path"
        Connections will be allowed over UNIX domain sockets where path is the location of a unix socket to listen for connections on.

    "none"
        VNC is initialized but not started. The monitor "change" command can be used to later start the VNC server.

    Following the display value there may be one or more option flags separated by commas. Valid options are

    "reverse"
        Connect to a listening VNC client via a "reverse" connection. The client is specified by the display. For reverse network connections (host:d,"reverse"), the d argument is a TCP port number, not a display number.

    "password"
        Require that password based authentication is used for client connections. The password must be set separately using the "change" command in the pcsys_monitor

    "tls"
        Require that client use TLS when communicating with the VNC server. This uses anonymous TLS credentials so is susceptible to a man-in-the-middle attack. It is recommended that this option be combined with either the x509 or x509verify options.

    "x509=/path/to/certificate/dir"
        Valid if tls is specified. Require that x509 credentials are used for negotiating the TLS session. The server will send its x509 certificate to the client. It is recommended that a password be set on the VNC server to provide authentication of the client when this is used. The path following this option specifies where the x509 certificates are to be loaded from. See the vnc_security section for details on generating certificates.

    "x509verify=/path/to/certificate/dir"
        Valid if tls is specified. Require that x509 credentials are used for negotiating the TLS session. The server will send its x509 certificate to the client, and request that the client send its own x509 certificate. The server will validate the client's certificate against the CA certificate, and reject clients when validation fails. If the certificate authority is trusted, this is a sufficient authentication mechanism. You may still wish to set a password on the VNC server as a second authentication layer. The path following this option specifies where the x509 certificates are to be loaded from. See the vnc_security section for details on generating certificates.

    "sasl"
        Require that the client use SASL to authenticate with the VNC server. The exact choice of authentication method used is controlled from the system / user's SASL configuration file for the 'qemu' service. This is typically found in /etc/sasl2/qemu.conf. If running QEMU as an unprivileged user, an environment variable SASL_CONF_PATH can be used to make it search alternate locations for the service config. While some SASL auth methods can also provide data encryption (eg GSSAPI), it is recommended that SASL always be combined with the 'tls' and 'x509' settings to enable use of SSL and server certificates. This ensures a data encryption preventing compromise of authentication credentials. See the vnc_security section for details on using SASL authentication.

    "acl"
        Turn on access control lists for checking of the x509 client certificate and SASL party. For x509 certs, the ACL check is made against the certificate's distinguished name. This is something that looks like "C=GB,O=ACME,L=Boston,CN=bob". For SASL party, the ACL check is made against the username, which depending on the SASL plugin, may include a realm component, eg "bob" or "bob@EXAMPLE.COM". When the acl flag is set, the initial access list will be empty, with a "deny" policy. Thus no one will be allowed to use the VNC server until the ACLs have been loaded. This can be achieved using the "acl" monitor command.

i386 target only:

-win2k-hack
    Use it when installing Windows 2000 to avoid a disk full bug. After Windows 2000 is installed, you no longer need this option (this option slows down the IDE transfers).

-rtc-td-hack
    Use it if you experience time drift problem in Windows with ACPI HAL. This option will try to figure out how many timer interrupts were not processed by the Windows guest and will re-inject them.

-no-fd-bootchk
    Disable boot signature checking for floppy disks in Bochs BIOS. It may be needed to boot from old floppy disks.

-no-acpi
    Disable ACPI (Advanced Configuration and Power Interface) support. Use it if your guest OS complains about ACPI problems (PC target machine only).

-no-hpet
    Disable HPET support.

-balloon none
    Disable balloon device.

-balloon virtio[,addr=addr]
    Enable virtio balloon device (default), optionally with PCI address addr.

-acpitable [sig=str][,rev=n][,oem_id=str][,oem_table_id=str][,oem_rev=n] [,asl_compiler_id=str][,asl_compiler_rev=n][,data=file1[:file2]...]
    Add ACPI table with specified header fields and context from specified files.

-smbios file=binary
    Load SMBIOS entry from binary file.

-smbios type=0[,vendor=str][,version=str][,date=str][,release=%d.%d]
    Specify SMBIOS type 0 fields

-smbios type=1[,manufacturer=str][,product=str][,version=str][,serial=str][,uuid=uuid][,sku=str][,family=str]
    Specify SMBIOS type 1 fields

Network options:

-net nic[,vlan=n][,macaddr=mac][,model=type][,name=name][,addr=addr][,vectors=v]
    Create a new Network Interface Card and connect it to VLAN n (n = 0 is the default). The NIC is an ne2k_pci by default on the PC target. Optionally, the MAC address can be changed to mac, the device address set to addr (PCI cards only), and a name can be assigned for use in monitor commands. Optionally, for PCI cards, you can specify the number v of MSI-X vectors that the card should have; this option currently only affects virtio cards; set v = 0 to disable MSI-X. If no -net option is specified, a single NIC is created. Qemu can emulate several different models of network card. Valid values for type are "virtio", "i82551", "i82557b", "i82559er", "ne2k_pci", "ne2k_isa", "pcnet", "rtl8139", "e1000", "smc91c111", "lance" and "mcf_fec". Not all devices are supported on all targets. Use -net nic,model=? for a list of available devices for your target.

-net user[,option][,option][,...]
    Use the user mode network stack which requires no administrator privilege to run. Valid options are:

    "vlan=n"
        Connect user mode stack to VLAN n (n = 0 is the default).

    "name=name"
        Assign symbolic name for use in monitor commands.

    "net=addr[/mask]"
        Set IP network address the guest will see. Optionally specify the netmask, either in the form a.b.c.d or as number of valid top-most bits. Default is 10.0.2.0/8.

    "host=addr"
        Specify the guest-visible address of the host. Default is the 2nd IP in the guest network, i.e. x.x.x.2.

    "restrict=y|yes|n|no"
        If this options is enabled, the guest will be isolated, i.e. it will not be able to contact the host and no guest IP packets will be routed over the host to the outside. This option does not affect explicitly set forwarding rule.

    "hostname=name"
        Specifies the client hostname reported by the builtin DHCP server.

    "dhcpstart=addr"
        Specify the first of the 16 IPs the built-in DHCP server can assign. Default is the 16th to 31st IP in the guest network, i.e. x.x.x.16 to x.x.x.31.

    "dns=addr"
        Specify the guest-visible address of the virtual nameserver. The address must be different from the host address. Default is the 3rd IP in the guest network, i.e. x.x.x.3.

    "tftp=dir"
        When using the user mode network stack, activate a built-in TFTP server. The files in dir will be exposed as the root of a TFTP server. The TFTP client on the guest must be configured in binary mode (use the command "bin" of the Unix TFTP client).

    "bootfile=file"
        When using the user mode network stack, broadcast file as the BOOTP filename. In conjunction with tftp, this can be used to network boot a guest from a local directory.

        Example (using pxelinux):

                qemu -hda linux.img -boot n -net user,tftp=/path/to/tftp/files,bootfile=/pxelinux.0

    "smb=dir[,smbserver=addr]"
        When using the user mode network stack, activate a built-in SMB server so that Windows OSes can access to the host files in dir transparently. The IP address of the SMB server can be set to addr. By default the 4th IP in the guest network is used, i.e. x.x.x.4.

        In the guest Windows OS, the line:

                10.0.2.4 smbserver

        must be added in the file C:\WINDOWS\LMHOSTS (for windows 9x/Me) or C:\WINNT\SYSTEM32\DRIVERS\ETC\LMHOSTS (Windows NT/2000).

        Then dir can be accessed in \\smbserver\qemu.

        Note that a SAMBA server must be installed on the host OS in /usr/sbin/smbd. QEMU was tested successfully with smbd versions from Red Hat 9, Fedora Core 3 and OpenSUSE 11.x.

    "hostfwd=[tcp|udp]:[hostaddr]:hostport-[guestaddr]:guestport"
        Redirect incoming TCP or UDP connections to the host port hostport to the guest IP address guestaddr on guest port guestport. If guestaddr is not specified, its value is x.x.x.15 (default first address given by the built-in DHCP server). By specifying hostaddr, the rule can be bound to a specific host interface. If no connection type is set, TCP is used. This option can be given multiple times.

        For example, to redirect host X11 connection from screen 1 to guest screen 0, use the following:

                # on the host
                qemu -net user,hostfwd=tcp:127.0.0.1:6001-:6000 [...]
                # this host xterm should open in the guest X11 server
                xterm -display :1

        To redirect telnet connections from host port 5555 to telnet port on the guest, use the following:

                # on the host
                qemu -net user,hostfwd=tcp:5555::23 [...]
                telnet localhost 5555

        Then when you use on the host "telnet localhost 5555", you connect to the guest telnet server.

    "guestfwd=[tcp]:server:port-dev"
        Forward guest TCP connections to the IP address server on port port to the character device dev. This option can be given multiple times.

    Note: Legacy stand-alone options -tftp, -bootp, -smb and -redir are still processed and applied to -net user. Mixing them with the new configuration syntax gives undefined results. Their use for new applications is discouraged as they will be removed from future versions.

-net tap[,vlan=n][,name=name][,fd=h][,ifname=name][,script=file][,downscript=dfile]
    Connect the host TAP network interface name to VLAN n, use the network script file to configure it and the network script dfile to deconfigure it. If name is not provided, the OS automatically provides one. fd=h can be used to specify the handle of an already opened host TAP interface. The default network configure script is /etc/qemu-ifup and the default network deconfigure script is /etc/qemu-ifdown. Use script=no or downscript=no to disable script execution. Example:

            qemu linux.img -net nic -net tap

    More complicated example (two NICs, each one connected to a TAP device)

            qemu linux.img -net nic,vlan=0 -net tap,vlan=0,ifname=tap0 \
            -net nic,vlan=1 -net tap,vlan=1,ifname=tap1

-net socket[,vlan=n][,name=name][,fd=h][,listen=[host]:port][,connect=host:port]
    Connect the VLAN n to a remote VLAN in another QEMU virtual machine using a TCP socket connection. If listen is specified, QEMU waits for incoming connections on port (host is optional). connect is used to connect to another QEMU instance using the listen option. fd=h specifies an already opened TCP socket.

    Example:

            # launch a first QEMU instance
            qemu linux.img -net nic,macaddr=52:54:00:12:34:56 \
            -net socket,listen=:1234
            # connect the VLAN 0 of this instance to the VLAN 0
            # of the first instance
            qemu linux.img -net nic,macaddr=52:54:00:12:34:57 \
            -net socket,connect=127.0.0.1:1234

-net socket[,vlan=n][,name=name][,fd=h][,mcast=maddr:port]
    Create a VLAN n shared with another QEMU virtual machines using a UDP multicast socket, effectively making a bus for every QEMU with same multicast address maddr and port. NOTES:

    1.  Several QEMU can be running on different hosts and share same bus (assuming correct multicast setup for these hosts).

    2.  mcast support is compatible with User Mode Linux (argument ethN=mcast), see <http://user-mode-linux.sf.net>.

    3.  Use fd=h to specify an already opened UDP multicast socket.

    Example:

            # launch one QEMU instance
            qemu linux.img -net nic,macaddr=52:54:00:12:34:56 \
            -net socket,mcast=230.0.0.1:1234
            # launch another QEMU instance on same "bus"
            qemu linux.img -net nic,macaddr=52:54:00:12:34:57 \
            -net socket,mcast=230.0.0.1:1234
            # launch yet another QEMU instance on same "bus"
            qemu linux.img -net nic,macaddr=52:54:00:12:34:58 \
            -net socket,mcast=230.0.0.1:1234

    Example (User Mode Linux compat.):

            # launch QEMU instance (note mcast address selected
            # is UML's default)
            qemu linux.img -net nic,macaddr=52:54:00:12:34:56 \
            -net socket,mcast=239.192.168.1:1102
            # launch UML
            /path/to/linux ubd0=/path/to/root_fs eth0=mcast

-net vde[,vlan=n][,name=name][,sock=socketpath][,port=n][,group=groupname][,mode=octalmode]
    Connect VLAN n to PORT n of a vde switch running on host and listening for incoming connections on socketpath. Use GROUP groupname and MODE octalmode to change default ownership and permissions for communication port. This option is available only if QEMU has been compiled with vde support enabled.

    Example:

            # launch vde switch
            vde_switch -F -sock /tmp/myswitch
            # launch QEMU instance
            qemu linux.img -net nic -net vde,sock=/tmp/myswitch

-net dump[,vlan=n][,file=file][,len=len]
    Dump network traffic on VLAN n to file file (qemu-vlan0.pcap by default). At most len bytes (64k by default) per packet are stored. The file format is libpcap, so it can be analyzed with tools such as tcpdump or Wireshark.

-net none
    Indicate that no network devices should be configured. It is used to override the default configuration (-net nic -net user) which is activated if no -net options are provided.

Bluetooth(R) options:

-bt hci[...]
    Defines the function of the corresponding Bluetooth HCI. -bt options are matched with the HCIs present in the chosen machine type. For example when emulating a machine with only one HCI built into it, only the first "-bt hci[...]" option is valid and defines the HCI's logic. The Transport Layer is decided by the machine type. Currently the machines "n800" and "n810" have one HCI and all other machines have none.

    The following three types are recognized:

    "-bt hci,null"
        (default) The corresponding Bluetooth HCI assumes no internal logic and will not respond to any HCI commands or emit events.

    "-bt hci,host[:id]"
        ("bluez" only) The corresponding HCI passes commands / events to / from the physical HCI identified by the name id (default: "hci0") on the computer running QEMU. Only available on "bluez" capable systems like Linux.

    "-bt hci[,vlan=n]"
        Add a virtual, standard HCI that will participate in the Bluetooth scatternet n (default 0). Similarly to -net VLANs, devices inside a bluetooth network n can only communicate with other devices in the same network (scatternet).

-bt vhci[,vlan=n]
    (Linux-host only) Create a HCI in scatternet n (default 0) attached to the host bluetooth stack instead of to the emulated target. This allows the host and target machines to participate in a common scatternet and communicate. Requires the Linux "vhci" driver installed. Can be used as following:

            qemu [...OPTIONS...] -bt hci,vlan=5 -bt vhci,vlan=5

-bt device:dev[,vlan=n]
    Emulate a bluetooth device dev and place it in network n (default 0). QEMU can only emulate one type of bluetooth devices currently:

    "keyboard"
        Virtual wireless keyboard implementing the HIDP bluetooth profile.

Linux/Multiboot boot specific:

When using these options, you can use a given Linux or Multiboot kernel without installing it in the disk image. It can be useful for easier testing of various kernels.

-kernel bzImage
    Use bzImage as kernel image. The kernel can be either a Linux kernel or in multiboot format.

-append cmdline
    Use cmdline as kernel command line

-initrd file
    Use file as initial ram disk.

-initrd "file1 arg=foo,file2"
    This syntax is only available with multiboot.

    Use file1 and file2 as modules and pass arg=foo as parameter to the first module.

Debug/Expert options:

-serial dev
    Redirect the virtual serial port to host character device dev. The default device is "vc" in graphical mode and "stdio" in non graphical mode.

    This option can be used several times to simulate up to 4 serial ports.

    Use "-serial none" to disable all serial ports.

    Available character devices are:

    "vc[:WxH]"
        Virtual console. Optionally, a width and height can be given in pixel with

                vc:800x600

        It is also possible to specify width or height in characters:

                vc:80Cx24C

    "pty"
        [Linux only] Pseudo TTY (a new PTY is automatically allocated)

    "none"
        No device is allocated.

    "null"
        void device

    "/dev/XXX"
        [Linux only] Use host tty, e.g. /dev/ttyS0. The host serial port parameters are set according to the emulated ones.

    "/dev/parportN"
        [Linux only, parallel port only] Use host parallel port N. Currently SPP and EPP parallel port features can be used.

    "file:filename"
        Write output to filename. No character can be read.

    "stdio"
        [Unix only] standard input/output

    "pipe:filename"
        name pipe filename

    "COMn"
        [Windows only] Use host serial port n

    "udp:[remote_host]:remote_port[@[src_ip]:src_port]"
        This implements UDP Net Console. When remote_host or src_ip are not specified they default to 0.0.0.0. When not using a specified src_port a random port is automatically chosen.

    "msmouse"
        Three button serial mouse. Configure the guest to use Microsoft protocol.

        If you just want a simple readonly console you can use "netcat" or "nc", by starting qemu with: "-serial udp::4555" and nc as: "nc -u -l -p 4555". Any time qemu writes something to that port it will appear in the netconsole session.

        If you plan to send characters back via netconsole or you want to stop and start qemu a lot of times, you should have qemu use the same source port each time by using something like "-serial udp::4555@4556" to qemu. Another approach is to use a patched version of netcat which can listen to a TCP port and send and receive characters via udp. If you have a patched version of netcat which activates telnet remote echo and single char transfer, then you can use the following options to step up a netcat redirector to allow telnet on port 5555 to access the qemu port.

        "Qemu Options:"
            -serial udp::4555@4556

        "netcat options:"
            -u -P 4555 -L 0.0.0.0:4556 -t -p 5555 -I -T

        "telnet options:"
            localhost 5555

    "tcp:[host]:port[,server][,nowait][,nodelay]"
        The TCP Net Console has two modes of operation. It can send the serial I/O to a location or wait for a connection from a location. By default the TCP Net Console is sent to host at the port. If you use the server option QEMU will wait for a client socket application to connect to the port before continuing, unless the "nowait" option was specified. The "nodelay" option disables the Nagle buffering algorithm. If host is omitted, 0.0.0.0 is assumed. Only one TCP connection at a time is accepted. You can use "telnet" to connect to the corresponding character device.

        "Example to send tcp console to 192.168.0.2 port 4444"
            -serial tcp:192.168.0.2:4444

        "Example to listen and wait on port 4444 for connection"
            -serial tcp::4444,server

        "Example to not wait and listen on ip 192.168.0.100 port 4444"
            -serial tcp:192.168.0.100:4444,server,nowait

    "telnet:host:port[,server][,nowait][,nodelay]"
        The telnet protocol is used instead of raw tcp sockets. The options work the same as if you had specified "-serial tcp". The difference is that the port acts like a telnet server or client using telnet option negotiation. This will also allow you to send the MAGIC_SYSRQ sequence if you use a telnet that supports sending the break sequence. Typically in unix telnet you do it with Control-] and then type "send break" followed by pressing the enter key.

    "unix:path[,server][,nowait]"
        A unix domain socket is used instead of a tcp socket. The option works the same as if you had specified "-serial tcp" except the unix domain socket path is used for connections.

    "mon:dev_string"
        This is a special option to allow the monitor to be multiplexed onto another serial port. The monitor is accessed with key sequence of Control-a and then pressing c. See monitor access pcsys_keys in the -nographic section for more keys. dev_string should be any one of the serial devices specified above. An example to multiplex the monitor onto a telnet server listening on port 4444 would be:

        "-serial mon:telnet::4444,server,nowait"
    "braille"
        Braille device. This will use BrlAPI to display the braille output on a real or fake device.

-parallel dev
    Redirect the virtual parallel port to host device dev (same devices as the serial port). On Linux hosts, /dev/parportN can be used to use hardware devices connected on the corresponding host parallel port.

    This option can be used several times to simulate up to 3 parallel ports.

    Use "-parallel none" to disable all parallel ports.

-monitor dev
    Redirect the monitor to host device dev (same devices as the serial port). The default device is "vc" in graphical mode and "stdio" in non graphical mode.

-pidfile file
    Store the QEMU process PID in file. It is useful if you launch QEMU from a script.

-singlestep
    Run the emulation in single step mode.

-S  Do not start CPU at startup (you must type 'c' in the monitor).

-gdb dev
    Wait for gdb connection on device dev. Typical connections will likely be TCP-based, but also UDP, pseudo TTY, or even stdio are reasonable use case. The latter is allowing to start qemu from within gdb and establish the connection via a pipe:

            (gdb) target remote | exec qemu -gdb stdio ...

-s  Shorthand for -gdb tcp::1234, i.e. open a gdbserver on TCP port 1234.

-d  Output log in /tmp/qemu.log

-hdachs c,h,s,[,t]
    Force hard disk 0 physical geometry (1 <= c <= 16383, 1 <= h <= 16, 1 <= s <= 63) and optionally force the BIOS translation mode (t=none, lba or auto). Usually QEMU can guess all those parameters. This option is useful for old MS-DOS disk images.

-L  path
    Set the directory for the BIOS, VGA BIOS and keymaps.

-bios file
    Set the filename for the BIOS.

-kernel-kqemu
    Enable KQEMU full virtualization (default is user mode only).

-enable-kqemu
    Enable KQEMU kernel module usage. KQEMU options are only available if KQEMU support is enabled when compiling.

-enable-kvm
    Enable KVM full virtualization support. This option is only available if KVM support is enabled when compiling.

-no-reboot
    Exit instead of rebooting.

-no-shutdown
    Don't exit QEMU on guest shutdown, but instead only stop the emulation. This allows for instance switching to monitor to commit changes to the disk image.

-loadvm file
    Start right away with a saved state ("loadvm" in monitor)

-daemonize
    Daemonize the QEMU process after initialization. QEMU will not detach from standard IO until it is ready to receive connections on any of its devices. This option is a useful way for external programs to launch QEMU without having to cope with initialization race conditions.

-option-rom file
    Load the contents of file as an option ROM. This option is useful to load things like EtherBoot.

-clock method
    Force the use of the given methods for timer alarm. To see what timers are available use -clock ?.

-localtime
    Set the real time clock to local time (the default is to UTC time). This option is needed to have correct date in MS-DOS or Windows.

-startdate date
    Set the initial date of the real time clock. Valid formats for date are: "now" or "2006-06-17T16:01:21" or "2006-06-17". The default value is "now".

-icount [N|auto]
    Enable virtual instruction counter. The virtual cpu will execute one instruction every 2^N ns of virtual time. If "auto" is specified then the virtual cpu speed will be automatically adjusted to keep virtual time within a few seconds of real time.

    Note that while this option can give deterministic behavior, it does not provide cycle accurate emulation. Modern CPUs contain superscalar out of order cores with complex cache hierarchies. The number of instructions executed often has little or no correlation with actual performance.

-watchdog model
    Create a virtual hardware watchdog device. Once enabled (by a guest action), the watchdog must be periodically polled by an agent inside the guest or else the guest will be restarted.

    The model is the model of hardware watchdog to emulate. Choices for model are: "ib700" (iBASE 700) which is a very simple ISA watchdog with a single timer, or "i6300esb" (Intel 6300ESB I/O controller hub) which is a much more featureful PCI-based dual-timer watchdog. Choose a model for which your guest has drivers.

    Use "-watchdog ?" to list available hardware models. Only one watchdog can be enabled for a guest.

-watchdog-action action
    The action controls what QEMU will do when the watchdog timer expires. The default is "reset" (forcefully reset the guest). Other possible actions are: "shutdown" (attempt to gracefully shutdown the guest), "poweroff" (forcefully poweroff the guest), "pause" (pause the guest), "debug" (print a debug message and continue), or "none" (do nothing).

    Note that the "shutdown" action requires that the guest responds to ACPI signals, which it may not be able to do in the sort of situations where the watchdog would have expired, and thus "-watchdog-action shutdown" is not recommended for production use.

    Examples:

    "-watchdog i6300esb -watchdog-action pause"
    "-watchdog ib700"
-echr numeric_ascii_value
    Change the escape character used for switching to the monitor when using monitor and serial sharing. The default is 0x01 when using the "-nographic" option. 0x01 is equal to pressing "Control-a". You can select a different character from the ascii control keys where 1 through 26 map to Control-a through Control-z. For instance you could use the either of the following to change the escape character to Control-t.

    "-echr 0x14"
    "-echr 20"
-virtioconsole c
    Set virtio console.

-chroot dir
    Immediately before starting guest execution, chroot to the specified directory. Especially useful in combination with -runas.

-runas user
    Immediately before starting guest execution, drop root privileges, switching to the specified user.

During the graphical emulation, you can use the following keys:

Ctrl-Alt-f
    Toggle full screen

Ctrl-Alt-n
    Switch to virtual console 'n'. Standard console mappings are:

    1   Target system display

    2   Monitor

    3   Serial port

Ctrl-Alt
    Toggle mouse and keyboard grab.

In the virtual consoles, you can use Ctrl-Up, Ctrl-Down, Ctrl-PageUp and Ctrl-PageDown to move in the back log.

During emulation, if you are using the -nographic option, use Ctrl-a h to get terminal commands:

Ctrl-a h
Ctrl-a ?
    Print this help

Ctrl-a x
    Exit emulator

Ctrl-a s
    Save disk data back to file (if -snapshot)

Ctrl-a t
    Toggle console timestamps

Ctrl-a b
    Send break (magic sysrq in Linux)

Ctrl-a c
    Switch between console and monitor

Ctrl-a Ctrl-a
    Send Ctrl-a

The following options are specific to the PowerPC emulation:

-g WxH[xDEPTH]
    Set the initial VGA graphic mode. The default is 800x600x15.

-prom-env string
    Set OpenBIOS variables in NVRAM, for example:

            qemu-system-ppc -prom-env 'auto-boot?=false' \
             -prom-env 'boot-device=hd:2,\yaboot' \
             -prom-env 'boot-args=conf=hd:2,\yaboot.conf'

    These variables are not used by Open Hack'Ware.

The following options are specific to the Sparc32 emulation:

-g WxHx[xDEPTH]
    Set the initial TCX graphic mode. The default is 1024x768x8, currently the only other possible mode is 1024x768x24.

-prom-env string
    Set OpenBIOS variables in NVRAM, for example:

            qemu-system-sparc -prom-env 'auto-boot?=false' \
             -prom-env 'boot-device=sd(0,2,0):d' -prom-env 'boot-args=linux single'

-M [SS-4|SS-5|SS-10|SS-20|SS-600MP|LX|Voyager|SPARCClassic|SPARCbook|SS-2|SS-1000|SS-2000]
    Set the emulated machine type. Default is SS-5.

The following options are specific to the Sparc64 emulation:

-prom-env string
    Set OpenBIOS variables in NVRAM, for example:

            qemu-system-sparc64 -prom-env 'auto-boot?=false'

-M [sun4u|sun4v|Niagara]
    Set the emulated machine type. The default is sun4u.

SEE ALSO
The HTML documentation of QEMU for more precise information and Linux user mode emulator invocation, as well as the FreeBSD host notes in pkg-message in the relevant qemu port directory.

AUTHOR
Fabrice Bellard